/*
 * LittleLibrary.java
 *
 * Created on 17 October 2002
 *
 * Test for interchange with EMF
 */

package startup;

import uk.ac.ukc.cs.kmf.toolgen.vsml.repository.*;
import uk.ac.ukc.cs.kmf.toolgen.vsml.repository.implementation.*;
import uk.ac.ukc.cs.kmf.toolgen.vsml.startup.implementation.vsmlStartup;
import uk.ac.ukc.cs.kmf.toolgen.vsml.AS.*;
import uk.ac.ukc.cs.kmf.ocl.*;
import uk.ac.ukc.cs.kmf.ocl.implementations.*;
import java.io.*;
import java.util.*;
import uk.ac.ukc.cs.kmf.ocl.utils.*;
import javax.swing.*;
import java.awt.event.*;

/**
 *
 * @author  sjhk
 */
public class LittleLibraryToolgen extends vsmlStartup {
    
    /** LittleLibrary test example */
    public LittleLibraryToolgen() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        // create repository
        IvsmlRepository rep = new vsmlRepository();
        String ASpath = "uk.ac.ukc.cs.kmf.toolgen.vsml.AS.";
        String SDpath = "uk.ac.ukc.cs.kmf.toolgen.vsml.SD.";
        String Sempath = "uk.ac.ukc.cs.kmf.toolgen.vsml.Semantics.";
        
        //replace default builders with own
        //AS builders
        rep.addLifecycle(ASpath+"Association", new lifecycle.AssociationLifecycle(rep));
        rep.addLifecycle(ASpath+"AssociationEnd", new lifecycle.AssociationEndLifecycle(rep));
        rep.addLifecycle(ASpath+"Class", new lifecycle.Class_Lifecycle(rep));
        rep.addLifecycle(ASpath+"Package", new lifecycle.Package_Lifecycle(rep));

        //get required builders from repository
        //AS builders
        lifecycle.Class_Lifecycle class_b = (lifecycle.Class_Lifecycle)(rep.getLifecycle(ASpath+"Class"));
        lifecycle.AssociationLifecycle assoc_b = (lifecycle.AssociationLifecycle)(rep.getLifecycle(ASpath+"Association"));
        lifecycle.Package_Lifecycle package_b = (lifecycle.Package_Lifecycle)(rep.getLifecycle(ASpath+"Package"));
        System.out.println("Lifecycles extracted.");

        //CREATE LittleLibrary
        //create package
        IPackage_ p_Library = (IPackage_)package_b.build(null,OCL.String("Library"));
        System.out.println("Built all packages.");
        

        //create classes and add to package
        IClass_ c_System = class_b.build(p_Library,OCL.String("System"));
        IClass_ c_Copy = class_b.build(p_Library,OCL.String("Copy"));
        IClass_ c_Publication = class_b.build(p_Library,OCL.String("Publication"));
        IClass_ c_Loan = class_b.build(p_Library,OCL.String("Loan"));
        IClass_ c_Reservation = class_b.build(p_Library,OCL.String("Reservation"));
        IClass_ c_User = class_b.build(p_Library,OCL.String("User"));
        IClass_ c_Boolean = class_b.build(p_Library,OCL.String("Boolean"));
        IClass_ c_String = class_b.build(p_Library,OCL.String("String"));
        System.out.println("Built all classes.");
        
        //create binary associations
        assoc_b.build(
                p_Library,c_System,c_Publication,
                OCL.String("publication"),OCL.Integer(0), OCL.Integer(0),
                OCL.String("system"),OCL.Integer(1),OCL.Integer(1));
        assoc_b.build(
                p_Library,c_System,c_User,
                OCL.String("user"),OCL.Integer(0), OCL.Integer(0),
                OCL.String("system"),OCL.Integer(1),OCL.Integer(1));
        assoc_b.build(
                p_Library,c_Copy,c_Publication,
                OCL.String("publication"),OCL.Integer(1),OCL.Integer(1),
                OCL.String("copy"),OCL.Integer(0),null);
        assoc_b.build(p_Library,c_Loan,c_Copy,
                OCL.String("copy"),OCL.Integer(1),OCL.Integer(1),
                OCL.String("loan"),OCL.Integer(0), OCL.Integer(0));        
        assoc_b.build(p_Library,c_Loan,c_User,
                OCL.String("user"),OCL.Integer(1),OCL.Integer(1),
                OCL.String("loan"),OCL.Integer(0), OCL.Integer(0));
        System.out.println("Built all binary associations.");
            
        //create unary associations
        assoc_b.build(
                p_Library,c_User,c_String,
                OCL.String("name"),OCL.Integer(1),OCL.Integer(1));        
        assoc_b.build(p_Library,c_Publication,c_String,
                OCL.String("title"),OCL.Integer(1),OCL.Integer(1));
        assoc_b.build(
                  p_Library,c_Copy,c_Loan,
                  OCL.String("currentLoan"),OCL.Integer(0),OCL.Integer(1));
        System.out.println("Built all unary associations.");
        
        vsmlBrowser browser = new vsmlBrowser();
        browser.setRep(rep);
        browser.show();
    }    
}
