/**
 *
 *  Class vsmlEvaluateAllVisitor.java
 *
 *  Generated by KMFStudio at 12 May 2003 11:17:56
 *  Visit http://www.cs.ukc.ac.uk/kmf
 *
 */

package uk.ac.ukc.cs.kmf.studio.vsml;

import java.util.*;

import uk.ac.ukc.cs.kmf.util.*;
import uk.ac.ukc.cs.kmf.ocl20.Syntax.Parser.*;
import uk.ac.ukc.cs.kmf.ocl20.Syntax.Contexts.*;
import uk.ac.ukc.cs.kmf.ocl20.Bridge.*;
import uk.ac.ukc.cs.kmf.ocl20.Semantics.*;
import uk.ac.ukc.cs.kmf.ocl20.Semantics.Contexts.*;
import uk.ac.ukc.cs.kmf.ocl20.Evaluation.*;
import uk.ac.ukc.cs.kmf.ocl20.Evaluation.Stdlib.*;

import uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd;
import uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_;
import uk.ac.ukc.cs.kmf.studio.vsml.AS.Association;
import uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_;

public class vsmlEvaluateAllVisitor$Class
	extends vsmlVisitor$Class
	implements vsmlEvaluateAllVisitor
{
	/** Visit class 'uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd' */
	public Object visit(uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::AssociationEnd inv owner_bidirectional: Set{owner}->forAll(x | x.associationEnd->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t1 = OCL.Set();
			Association t2 = (Association)self.getOwner();
			t1 = t1.including(t2);
			Association x = null;
			IOclBoolean t3 = OCL.Boolean(true);
			java.util.Iterator t4 = OCL.impl(t1).iterator();
			while (t4.hasNext()) {
			    x = (Association)t4.next();
			    IOclOrderedSet t5 = OCL.OrderedSet(x.getAssociationEnd());
			    IOclBoolean t6 = (IOclBoolean)t5.includes(self);
			    t3 = t6;
			    if(!OCL.impl(t3)) break;
			}
			log.reportMessage(": "+t3);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::AssociationEnd inv source_bidirectional: Set{source}->forAll(x | x.sourceOf->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t7 = OCL.Set();
			Class_ t8 = (Class_)self.getSource();
			t7 = t7.including(t8);
			Class_ x = null;
			IOclBoolean t9 = OCL.Boolean(true);
			java.util.Iterator t10 = OCL.impl(t7).iterator();
			while (t10.hasNext()) {
			    x = (Class_)t10.next();
			    IOclSet t11 = OCL.Set(x.getSourceOf());
			    IOclBoolean t12 = (IOclBoolean)t11.includes(self);
			    t9 = t12;
			    if(!OCL.impl(t9)) break;
			}
			log.reportMessage(": "+t9);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::AssociationEnd inv target_bidirectional: Set{target}->forAll(x | x.targetOf->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t13 = OCL.Set();
			Class_ t14 = (Class_)self.getTarget();
			t13 = t13.including(t14);
			Class_ x = null;
			IOclBoolean t15 = OCL.Boolean(true);
			java.util.Iterator t16 = OCL.impl(t13).iterator();
			while (t16.hasNext()) {
			    x = (Class_)t16.next();
			    IOclSet t17 = OCL.Set(x.getTargetOf());
			    IOclBoolean t18 = (IOclBoolean)t17.includes(self);
			    t15 = t18;
			    if(!OCL.impl(t15)) break;
			}
			log.reportMessage(": "+t15);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::AssociationEnd inv otherEnd_source_is_target : otherEnd -> isEmpty() or ( otherEnd . target = source and otherEnd . source = target )";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'or'
			IOclBoolean t19;
			try {
			    IOclSet t20 = OCL.Set();
			    AssociationEnd t21 = (AssociationEnd)self.getOtherEnd();
			    t20 = t20.including(t21);
			    IOclBoolean t22 = (IOclBoolean)t20.isEmpty();
			    t19 = t22;
			} catch (Exception e) {
			    t19 = OCL.Undefined();
			}
			IOclBoolean t23;
			try {
			    // 'and'
			    IOclBoolean t24;
			    try {
			        AssociationEnd t25 = (AssociationEnd)self.getOtherEnd();
			        Class_ t26 = (Class_)t25.getTarget();
			        Class_ t27 = (Class_)self.getSource();
			        IOclBoolean t28 = OCL.equalTo(t26, t27);
			        t24 = t28;
			    } catch (Exception e) {
			        t24 = OCL.Undefined();
			    }
			    IOclBoolean t29;
			    try {
			        AssociationEnd t30 = (AssociationEnd)self.getOtherEnd();
			        Class_ t31 = (Class_)t30.getSource();
			        Class_ t32 = (Class_)self.getTarget();
			        IOclBoolean t33 = OCL.equalTo(t31, t32);
			        t29 = t33;
			    } catch (Exception e) {
			        t29 = OCL.Undefined();
			    }
			    IOclBoolean t34 = OCL.andOper(t24, t29);
			    t23 = t34;
			} catch (Exception e) {
			    t23 = OCL.Undefined();
			}
			IOclBoolean t35 = OCL.orOper(t19, t23);
			log.reportMessage(": "+t35);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::AssociationEnd inv upper_greater_than_lower : upper -> isEmpty() or upper >= lower";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'or'
			IOclBoolean t36;
			try {
			    IOclSet t37 = OCL.Set();
			    IOclInteger t38 = OCL.Integer(self.getUpper());
			    t37 = t37.including(t38);
			    IOclBoolean t39 = (IOclBoolean)t37.isEmpty();
			    t36 = t39;
			} catch (Exception e) {
			    t36 = OCL.Undefined();
			}
			IOclBoolean t40;
			try {
			    IOclInteger t41 = OCL.Integer(self.getUpper());
			    IOclInteger t42 = OCL.Integer(self.getLower());
			    IOclBoolean t43 = (IOclBoolean)t41.greaterThanOrEqualTo(t42);
			    t40 = t43;
			} catch (Exception e) {
			    t40 = OCL.Undefined();
			}
			IOclBoolean t44 = OCL.orOper(t36, t40);
			log.reportMessage(": "+t44);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::AssociationEnd inv otherEnd_owner_is_owner_and_not_self : otherEnd -> isEmpty() or ( otherEnd . owner = owner and not ( otherEnd = self ) )";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'or'
			IOclBoolean t45;
			try {
			    IOclSet t46 = OCL.Set();
			    AssociationEnd t47 = (AssociationEnd)self.getOtherEnd();
			    t46 = t46.including(t47);
			    IOclBoolean t48 = (IOclBoolean)t46.isEmpty();
			    t45 = t48;
			} catch (Exception e) {
			    t45 = OCL.Undefined();
			}
			IOclBoolean t49;
			try {
			    // 'and'
			    IOclBoolean t50;
			    try {
			        AssociationEnd t51 = (AssociationEnd)self.getOtherEnd();
			        Association t52 = (Association)t51.getOwner();
			        Association t53 = (Association)self.getOwner();
			        IOclBoolean t54 = OCL.equalTo(t52, t53);
			        t50 = t54;
			    } catch (Exception e) {
			        t50 = OCL.Undefined();
			    }
			    IOclBoolean t55;
			    try {
			        // 'not'
			        IOclBoolean t56;
			        try {
			            AssociationEnd t57 = (AssociationEnd)self.getOtherEnd();
			            IOclBoolean t58 = OCL.equalTo(t57, self);
			            t56 = t58;
			        } catch (Exception e) {
			            t56 = OCL.Undefined();
			        }
			        IOclBoolean t59 = OCL.notOper(t56);
			        t55 = t59;
			    } catch (Exception e) {
			        t55 = OCL.Undefined();
			    }
			    IOclBoolean t60 = OCL.andOper(t50, t55);
			    t49 = t60;
			} catch (Exception e) {
			    t49 = OCL.Undefined();
			}
			IOclBoolean t61 = OCL.orOper(t45, t49);
			log.reportMessage(": "+t61);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_' */
	public Object visit(uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv owner_bidirectional: Set{owner}->forAll(x | x.package_->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t62 = OCL.Set();
			Package_ t63 = (Package_)self.getOwner();
			t62 = t62.including(t63);
			Package_ x = null;
			IOclBoolean t64 = OCL.Boolean(true);
			java.util.Iterator t65 = OCL.impl(t62).iterator();
			while (t65.hasNext()) {
			    x = (Package_)t65.next();
			    IOclSet t66 = OCL.Set(x.getPackage_());
			    IOclBoolean t67 = (IOclBoolean)t66.includes(self);
			    t64 = t67;
			    if(!OCL.impl(t64)) break;
			}
			log.reportMessage(": "+t64);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv package__size: 0<=package_->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t68 = OCL.Set(self.getPackage_());
			IOclInteger t69 = (IOclInteger)t68.size();
			IOclBoolean t70 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t69);
			log.reportMessage(": "+t70);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv package__bidirectional: package_->forAll(x | x.owner=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t71 = OCL.Set(self.getPackage_());
			Package_ x = null;
			IOclBoolean t72 = OCL.Boolean(true);
			java.util.Iterator t73 = OCL.impl(t71).iterator();
			while (t73.hasNext()) {
			    x = (Package_)t73.next();
			    Package_ t74 = (Package_)x.getOwner();
			    IOclBoolean t75 = OCL.equalTo(t74, self);
			    t72 = t75;
			    if(!OCL.impl(t72)) break;
			}
			log.reportMessage(": "+t72);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv class__size: 0<=class_->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t76 = OCL.Set(self.getClass_());
			IOclInteger t77 = (IOclInteger)t76.size();
			IOclBoolean t78 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t77);
			log.reportMessage(": "+t78);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv class__bidirectional: class_->forAll(x | x.owner=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t79 = OCL.Set(self.getClass_());
			Class_ x = null;
			IOclBoolean t80 = OCL.Boolean(true);
			java.util.Iterator t81 = OCL.impl(t79).iterator();
			while (t81.hasNext()) {
			    x = (Class_)t81.next();
			    Package_ t82 = (Package_)x.getOwner();
			    IOclBoolean t83 = OCL.equalTo(t82, self);
			    t80 = t83;
			    if(!OCL.impl(t80)) break;
			}
			log.reportMessage(": "+t80);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv association_size: 0<=association->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t84 = OCL.Set(self.getAssociation());
			IOclInteger t85 = (IOclInteger)t84.size();
			IOclBoolean t86 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t85);
			log.reportMessage(": "+t86);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv association_bidirectional: association->forAll(x | x.owner=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t87 = OCL.Set(self.getAssociation());
			Association x = null;
			IOclBoolean t88 = OCL.Boolean(true);
			java.util.Iterator t89 = OCL.impl(t87).iterator();
			while (t89.hasNext()) {
			    x = (Association)t89.next();
			    Package_ t90 = (Package_)x.getOwner();
			    IOclBoolean t91 = OCL.equalTo(t90, self);
			    t88 = t91;
			    if(!OCL.impl(t88)) break;
			}
			log.reportMessage(": "+t88);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv package_names_unique : package_ . name -> asSet() -> asBag() = package_ . name";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'collect' iterator
			// 'collectedNested' iterator
			IOclSet t92 = OCL.Set(self.getPackage_());
			Package_ _tempIt1 = null;
			IOclBag t93 = OCL.Bag();;
			java.util.Iterator t94 = OCL.impl(t92).iterator();
			while (t94.hasNext()) {
			    _tempIt1 = (Package_)t94.next();
			    IOclString t95 = OCL.String(_tempIt1.getName());
			    t93 = t93.including(t95);
			}
			t93 = t93.flatten();
			IOclSet t96 = (IOclSet)t93.asSet();
			IOclBag t97 = (IOclBag)t96.asBag();
			// 'collect' iterator
			// 'collectedNested' iterator
			IOclSet t98 = OCL.Set(self.getPackage_());
			Package_ _tempIt0 = null;
			IOclBag t99 = OCL.Bag();;
			java.util.Iterator t100 = OCL.impl(t98).iterator();
			while (t100.hasNext()) {
			    _tempIt0 = (Package_)t100.next();
			    IOclString t101 = OCL.String(_tempIt0.getName());
			    t99 = t99.including(t101);
			}
			t99 = t99.flatten();
			IOclBoolean t102 = OCL.equalTo(t97, t99);
			log.reportMessage(": "+t102);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv assoc_names_unique : association . name -> asSet() -> asBag() = association . name";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'collect' iterator
			// 'collectedNested' iterator
			IOclSet t103 = OCL.Set(self.getAssociation());
			Association _tempIt3 = null;
			IOclBag t104 = OCL.Bag();;
			java.util.Iterator t105 = OCL.impl(t103).iterator();
			while (t105.hasNext()) {
			    _tempIt3 = (Association)t105.next();
			    IOclString t106 = OCL.String(_tempIt3.getName());
			    t104 = t104.including(t106);
			}
			t104 = t104.flatten();
			IOclSet t107 = (IOclSet)t104.asSet();
			IOclBag t108 = (IOclBag)t107.asBag();
			// 'collect' iterator
			// 'collectedNested' iterator
			IOclSet t109 = OCL.Set(self.getAssociation());
			Association _tempIt2 = null;
			IOclBag t110 = OCL.Bag();;
			java.util.Iterator t111 = OCL.impl(t109).iterator();
			while (t111.hasNext()) {
			    _tempIt2 = (Association)t111.next();
			    IOclString t112 = OCL.String(_tempIt2.getName());
			    t110 = t110.including(t112);
			}
			t110 = t110.flatten();
			IOclBoolean t113 = OCL.equalTo(t108, t110);
			log.reportMessage(": "+t113);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv class_names_unique : class_ . name -> asSet() -> asBag() = class_ . name";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'collect' iterator
			// 'collectedNested' iterator
			IOclSet t114 = OCL.Set(self.getClass_());
			Class_ _tempIt5 = null;
			IOclBag t115 = OCL.Bag();;
			java.util.Iterator t116 = OCL.impl(t114).iterator();
			while (t116.hasNext()) {
			    _tempIt5 = (Class_)t116.next();
			    IOclString t117 = OCL.String(_tempIt5.getName());
			    t115 = t115.including(t117);
			}
			t115 = t115.flatten();
			IOclSet t118 = (IOclSet)t115.asSet();
			IOclBag t119 = (IOclBag)t118.asBag();
			// 'collect' iterator
			// 'collectedNested' iterator
			IOclSet t120 = OCL.Set(self.getClass_());
			Class_ _tempIt4 = null;
			IOclBag t121 = OCL.Bag();;
			java.util.Iterator t122 = OCL.impl(t120).iterator();
			while (t122.hasNext()) {
			    _tempIt4 = (Class_)t122.next();
			    IOclString t123 = OCL.String(_tempIt4.getName());
			    t121 = t121.including(t123);
			}
			t121 = t121.flatten();
			IOclBoolean t124 = OCL.equalTo(t119, t121);
			log.reportMessage(": "+t124);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.kmf.studio.vsml.AS.Association' */
	public Object visit(uk.ac.ukc.cs.kmf.studio.vsml.AS.Association self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Association inv associationEnd_size: 1<=associationEnd->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclOrderedSet t125 = OCL.OrderedSet(self.getAssociationEnd());
			IOclInteger t126 = (IOclInteger)t125.size();
			IOclBoolean t127 = (IOclBoolean)OCL.Integer(1).lessThanOrEqualTo(t126);
			log.reportMessage(": "+t127);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Association inv associationEnd_bidirectional: associationEnd->forAll(x | x.owner=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclOrderedSet t128 = OCL.OrderedSet(self.getAssociationEnd());
			AssociationEnd x = null;
			IOclBoolean t129 = OCL.Boolean(true);
			java.util.Iterator t130 = OCL.impl(t128).iterator();
			while (t130.hasNext()) {
			    x = (AssociationEnd)t130.next();
			    Association t131 = (Association)x.getOwner();
			    IOclBoolean t132 = OCL.equalTo(t131, self);
			    t129 = t132;
			    if(!OCL.impl(t129)) break;
			}
			log.reportMessage(": "+t129);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Association inv owner_bidirectional: Set{owner}->forAll(x | x.association->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t133 = OCL.Set();
			Package_ t134 = (Package_)self.getOwner();
			t133 = t133.including(t134);
			Package_ x = null;
			IOclBoolean t135 = OCL.Boolean(true);
			java.util.Iterator t136 = OCL.impl(t133).iterator();
			while (t136.hasNext()) {
			    x = (Package_)t136.next();
			    IOclSet t137 = OCL.Set(x.getAssociation());
			    IOclBoolean t138 = (IOclBoolean)t137.includes(self);
			    t135 = t138;
			    if(!OCL.impl(t135)) break;
			}
			log.reportMessage(": "+t135);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Association inv one_at_other_of_two_and_vice_versa : associationEnd -> size() = 1 or ( associationEnd -> size() = 2 and associationEnd -> first() . otherEnd = associationEnd -> last() and associationEnd -> last() . otherEnd = associationEnd -> first() )";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'or'
			IOclBoolean t139;
			try {
			    IOclOrderedSet t140 = OCL.OrderedSet(self.getAssociationEnd());
			    IOclInteger t141 = (IOclInteger)t140.size();
			    IOclBoolean t142 = OCL.equalTo(t141, OCL.Integer(1));
			    t139 = t142;
			} catch (Exception e) {
			    t139 = OCL.Undefined();
			}
			IOclBoolean t143;
			try {
			    // 'and'
			    IOclBoolean t144;
			    try {
			        // 'and'
			        IOclBoolean t145;
			        try {
			            IOclOrderedSet t146 = OCL.OrderedSet(self.getAssociationEnd());
			            IOclInteger t147 = (IOclInteger)t146.size();
			            IOclBoolean t148 = OCL.equalTo(t147, OCL.Integer(2));
			            t145 = t148;
			        } catch (Exception e) {
			            t145 = OCL.Undefined();
			        }
			        IOclBoolean t149;
			        try {
			            IOclOrderedSet t150 = OCL.OrderedSet(self.getAssociationEnd());
			            AssociationEnd t151 = (AssociationEnd)t150.first();
			            AssociationEnd t152 = (AssociationEnd)t151.getOtherEnd();
			            IOclOrderedSet t153 = OCL.OrderedSet(self.getAssociationEnd());
			            AssociationEnd t154 = (AssociationEnd)t153.last();
			            IOclBoolean t155 = OCL.equalTo(t152, t154);
			            t149 = t155;
			        } catch (Exception e) {
			            t149 = OCL.Undefined();
			        }
			        IOclBoolean t156 = OCL.andOper(t145, t149);
			        t144 = t156;
			    } catch (Exception e) {
			        t144 = OCL.Undefined();
			    }
			    IOclBoolean t157;
			    try {
			        IOclOrderedSet t158 = OCL.OrderedSet(self.getAssociationEnd());
			        AssociationEnd t159 = (AssociationEnd)t158.last();
			        AssociationEnd t160 = (AssociationEnd)t159.getOtherEnd();
			        IOclOrderedSet t161 = OCL.OrderedSet(self.getAssociationEnd());
			        AssociationEnd t162 = (AssociationEnd)t161.first();
			        IOclBoolean t163 = OCL.equalTo(t160, t162);
			        t157 = t163;
			    } catch (Exception e) {
			        t157 = OCL.Undefined();
			    }
			    IOclBoolean t164 = OCL.andOper(t144, t157);
			    t143 = t164;
			} catch (Exception e) {
			    t143 = OCL.Undefined();
			}
			IOclBoolean t165 = OCL.orOper(t139, t143);
			log.reportMessage(": "+t165);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_' */
	public Object visit(uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Class_ inv superClass_size: 0<=superClass->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t166 = OCL.Set(self.getSuperClass());
			IOclInteger t167 = (IOclInteger)t166.size();
			IOclBoolean t168 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t167);
			log.reportMessage(": "+t168);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Class_ inv owner_bidirectional: Set{owner}->forAll(x | x.class_->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t169 = OCL.Set();
			Package_ t170 = (Package_)self.getOwner();
			t169 = t169.including(t170);
			Package_ x = null;
			IOclBoolean t171 = OCL.Boolean(true);
			java.util.Iterator t172 = OCL.impl(t169).iterator();
			while (t172.hasNext()) {
			    x = (Package_)t172.next();
			    IOclSet t173 = OCL.Set(x.getClass_());
			    IOclBoolean t174 = (IOclBoolean)t173.includes(self);
			    t171 = t174;
			    if(!OCL.impl(t171)) break;
			}
			log.reportMessage(": "+t171);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Class_ inv sourceOf_size: 0<=sourceOf->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t175 = OCL.Set(self.getSourceOf());
			IOclInteger t176 = (IOclInteger)t175.size();
			IOclBoolean t177 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t176);
			log.reportMessage(": "+t177);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Class_ inv sourceOf_bidirectional: sourceOf->forAll(x | x.source=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t178 = OCL.Set(self.getSourceOf());
			AssociationEnd x = null;
			IOclBoolean t179 = OCL.Boolean(true);
			java.util.Iterator t180 = OCL.impl(t178).iterator();
			while (t180.hasNext()) {
			    x = (AssociationEnd)t180.next();
			    Class_ t181 = (Class_)x.getSource();
			    IOclBoolean t182 = OCL.equalTo(t181, self);
			    t179 = t182;
			    if(!OCL.impl(t179)) break;
			}
			log.reportMessage(": "+t179);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Class_ inv targetOf_size: 0<=targetOf->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t183 = OCL.Set(self.getTargetOf());
			IOclInteger t184 = (IOclInteger)t183.size();
			IOclBoolean t185 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t184);
			log.reportMessage(": "+t185);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Class_ inv targetOf_bidirectional: targetOf->forAll(x | x.target=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t186 = OCL.Set(self.getTargetOf());
			AssociationEnd x = null;
			IOclBoolean t187 = OCL.Boolean(true);
			java.util.Iterator t188 = OCL.impl(t186).iterator();
			while (t188.hasNext()) {
			    x = (AssociationEnd)t188.next();
			    Class_ t189 = (Class_)x.getTarget();
			    IOclBoolean t190 = OCL.equalTo(t189, self);
			    t187 = t190;
			    if(!OCL.impl(t187)) break;
			}
			log.reportMessage(": "+t187);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Class_ inv names_of_assoc_ends_are_unique : sourceOf . name -> asSet() -> asBag() = sourceOf . name";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'collect' iterator
			// 'collectedNested' iterator
			IOclSet t191 = OCL.Set(self.getSourceOf());
			AssociationEnd _tempIt7 = null;
			IOclBag t192 = OCL.Bag();;
			java.util.Iterator t193 = OCL.impl(t191).iterator();
			while (t193.hasNext()) {
			    _tempIt7 = (AssociationEnd)t193.next();
			    IOclString t194 = OCL.String(_tempIt7.getName());
			    t192 = t192.including(t194);
			}
			t192 = t192.flatten();
			IOclSet t195 = (IOclSet)t192.asSet();
			IOclBag t196 = (IOclBag)t195.asBag();
			// 'collect' iterator
			// 'collectedNested' iterator
			IOclSet t197 = OCL.Set(self.getSourceOf());
			AssociationEnd _tempIt6 = null;
			IOclBag t198 = OCL.Bag();;
			java.util.Iterator t199 = OCL.impl(t197).iterator();
			while (t199.hasNext()) {
			    _tempIt6 = (AssociationEnd)t199.next();
			    IOclString t200 = OCL.String(_tempIt6.getName());
			    t198 = t198.including(t200);
			}
			t198 = t198.flatten();
			IOclBoolean t201 = OCL.equalTo(t196, t198);
			log.reportMessage(": "+t201);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
}
